#include<AT89C51.h>

signed char command=0;

void UART_ISR(void) interrupt 4
{
command=(signed char)SBUF;
RI=0;
}

void main(void)
{
signed char i;
TMOD=0x21;
TH1=0xFD;
SCON=0x50;
ES=1;
EA=1;
TR1=1;
while(1)
	{
	if(command==0)	// Turn Off
		{
		P2_0=1;
		P2_1=1;
		P2_2=0;
		P2_3=0;
		}
	if(command>0)	// Turn to Right
		{
		P2_1=1;
		P2_2=0;
		P2_0=0;
		P2_3=1;
		for(i=0;i<command;i++)
			asm {0x00};
		P2_3=0;
		for(i=command;i<127;i++)
			asm {0x00};
		}
	if(command<0)	// Turn to Left
		{
		P2_0=1;
		P2_3=0;
		P2_1=0;
		P2_2=1;
		for(i=0;i>command;i--)
			asm {0x00};
		P2_2=0;		
		for(i=command;i>-128;i--)
			asm {0x00};
		}
	}
}
